﻿Imports DotNetNuke
Namespace WESNet.DNN.Modules.ImageEditor

    Partial Class ImageEditor
        Inherits Entities.Modules.PortalModuleBase

        Protected Sub ImageEditor_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            Dim s As String
            Dim sz As Size
            If Not IsPostBack Then
                With ImageEditorControl1
                    .ModuleID = Me.ModuleId
                    .Caption = GetSetting("Caption", String.Empty)
                    .AllowModeSwitch = GetSetting("AllowModeSwitch", False)
                    .EditMode = CType([Enum].Parse(GetType(DotNetNuke.UI.WebControls.PropertyEditorMode), GetSetting("InitialMode", DotNetNuke.UI.WebControls.PropertyEditorMode.Edit)), DotNetNuke.UI.WebControls.PropertyEditorMode)
                    .PreviewSize = ParseSize(GetSetting("PreviewSize", "400 x 300"))
                    .ImageEditor.ToolbarOrientation = CType([Enum].Parse(GetType(System.Web.UI.WebControls.Orientation), GetSetting("Orientation", System.Web.UI.WebControls.Orientation.Horizontal)), System.Web.UI.WebControls.Orientation)
                    .ImageEditor.ShowCropperOnInit = GetSetting("ShowCropperOnInit", False)
                    .ImageEditor.CaptureKeys = GetSetting("CaptureKeys", True)
                    If GetSetting("UseMinCropSize", False) Then
                        .ImageEditor.MinCropSize = ParseSize(GetSetting("MinCropSize", ""))
                    End If
                    If GetSetting("UseMaxCropSize", False) Then
                        .ImageEditor.MaxCropSize = ParseSize(GetSetting("MaxCropSize", ""))
                    End If
                    If GetSetting("UseAspectRatio", False) Then
                        .ImageEditor.AspectRatio = ParseSize(GetSetting("AspectRatio", ""))
                    End If
                    .ImageEditor.Rescale = GetSetting("Rescale", True)
                    .AllowFileOpen = GetSetting("AllowFileOpen", True)
                    .AllowFileUpload = GetSetting("AllowFileUpload", True)
                    .AllowFileSave = GetSetting("AllowFileSave", True)
                    .AllowFileSaveAs = GetSetting("AllowFileSaveAs", True)
                    .ShowFolders = GetSetting("ShowFolders", True)
                    .ShowSecure = GetSetting("ShowSecure", True)
                    .ShowDatabase = GetSetting("ShowDatabase", True)
                    .ShowFiles = GetSetting("ShowFiles", True)
                    .AutoResize = GetSetting("AutoResize", True)
                    If .AutoResize Then
                        .MaxImageSize = ParseSize(GetSetting("MaxImageSize", "1024 x 480"))
                    End If
                    .AutoThumbnail = GetSetting("AutoThumbnail", True)
                    If .AutoThumbnail Then
                        .MaxThumbSize = ParseSize(GetSetting("MaxThumbSize", "200 x 200"))
                        .ThumbSuffix = GetSetting("ThumbSuffix", "_th")
                    End If

                    s = GetSetting("ViewSize", String.Empty)
                    Select Case s
                        Case "Full"
                            .ViewSize = Size.Empty
                        Case "Thumb"
                            .ViewSize = .MaxThumbSize
                        Case Else
                            sz = ParseSize(GetSetting("ViewSize", ""))
                            .ViewSize = sz
                    End Select
                    If GetSetting("RememberLastFilepath", True) Then
                        .FilePath = GetSetting("Filepath", PortalSettings.HomeDirectory)
                    End If
                End With
            End If
        End Sub

        Private Function GetSetting(Of T)(ByVal key As String, ByVal defaultVaue As T) As T
            Dim obj As Object = Settings(key)
            If obj Is Nothing OrElse CStr(key) = String.Empty Then
                Return defaultVaue
            Else
                If TypeOf defaultVaue Is System.Enum Then
                    Return CType([Enum].Parse(GetType(T), CStr(obj)), T)
                Else
                    Return CType(Settings(key), T)
                End If
            End If
        End Function

        Private Overloads Function ParseSize(ByVal xText As String, ByVal yText As String) As Size
            Dim X, Y As Integer
            If Not String.IsNullOrEmpty(xText.Trim()) Then
                X = Integer.Parse(xText.Trim())
            End If
            If Not String.IsNullOrEmpty(yText.Trim()) Then
                Y = Integer.Parse(yText.Trim())
            End If
            If (X = 0 And Y = 0) Then
                Return Size.Empty
            Else
                Return New Size(X, Y)
            End If
        End Function

        Private Overloads Function ParseSize(ByVal WbyH As String) As Size
            Dim value As String = WbyH.Trim()
            If Not String.IsNullOrEmpty(value) Then
                Dim m As RegularExpressions.Match = Regex.Match(value, "^(?<x>\d{1,4})\s*x\s*(?<y>\d{1,4})$")
                If m.Success Then
                    Return ParseSize(m.Groups(1).Value, m.Groups(2).Value)
                End If
            End If
            Return Size.Empty
        End Function


        Protected Sub ImageEditorControl1_FilepathChanged(ByVal e As System.EventArgs) Handles ImageEditorControl1.FilepathChanged
            If GetSetting("RememberLastFilepath", True) Then
                Dim mc As New Entities.Modules.ModuleController
                mc.UpdateModuleSetting(ModuleId, "Filepath", ImageEditorControl1.FilePath)
                SynchronizeModule()
            End If
        End Sub
    End Class

End Namespace