Imports DotNetNuke
Imports System.Web.UI

Namespace WESNet.DNN.Modules.ImageEditor

    Partial Class ImageEditorDemoSettings
        Inherits Entities.Modules.ModuleSettingsBase

#Region "Base Method Implementations"

        Public Overrides Sub LoadSettings()
            Try
                If (Page.IsPostBack = False) Then
                    tbFolder.Text = GetSetting("Folder", "/")
                    tbInitialFilename.Text = GetSetting("InitialFilename", "")
                End If
            Catch exc As Exception           'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        Public Overrides Sub UpdateSettings()
            If Not Page.IsValid Then Exit Sub
            Try
                Dim objModules As New Entities.Modules.ModuleController
                Dim objPortalSecurity As New Security.PortalSecurity
                With objModules
                    .UpdateModuleSetting(ModuleId, "Folder", objPortalSecurity.InputFilter(tbFolder.Text, PortalSecurity.FilterFlag.NoMarkup Or PortalSecurity.FilterFlag.NoSQL))
                    .UpdateModuleSetting(ModuleId, "InitialFilename", objPortalSecurity.InputFilter(tbInitialFilename.Text, PortalSecurity.FilterFlag.NoMarkup Or PortalSecurity.FilterFlag.NoSQL))
                End With
                ' refresh cache
                SynchronizeModule()
            Catch exc As Exception           'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

#End Region

#Region "Helper methods"

        Private Function GetSetting(Of T)(ByVal key As String, ByVal defaultVaue As T) As T
            Dim obj As Object = Settings(key)
            If obj Is Nothing OrElse CStr(key) = String.Empty Then
                Return defaultVaue
            Else
                If TypeOf defaultVaue Is System.Enum Then
                    Return CType([Enum].Parse(GetType(T), CStr(obj)), T)
                Else
                    Return CType(Settings(key), T)
                End If
            End If
        End Function

#End Region

    End Class

End Namespace

