Imports DotNetNuke
Imports System.Web.UI

Namespace WESNet.DNN.Modules.WESNet_ImageEditor

    Partial Class Settings
        Inherits Entities.Modules.ModuleSettingsBase

#Region "Base Method Implementations"

        Public Overrides Sub LoadSettings()
            Dim sz As Size
            Try
                If (Page.IsPostBack = False) Then
                    tbCaption.Text = GetSetting("Caption", String.Empty)
                    cbAllowModeSwitch.Checked = GetSetting("AllowModeSwitch", False)
                    rblInitialMode.SelectedValue = GetSetting("InitialMode", "View")
                    rblViewSize.SelectedValue = GetSetting("ViewSize", "Full")
                    rblPreviewSize.SelectedValue = GetSetting("PreviewSize", "400 x 300")
                    rblOrientation.SelectedValue = GetSetting("Orientation", "Horizontal")
                    cbShowCropperOnInit.Checked = GetSetting("ShowCropperOnInit", False)
                    cbCaptureKeys.Checked = GetSetting("CaptureKeys", True)
                    cbMinCropSize.Checked = GetSetting("UseMinCropSize", False)
                    sz = ParseSize(GetSetting("MinCropSize", ""))
                    tbMinCropWidth.Text = sz.Width.ToString
                    tbMinCropHeight.Text = sz.Height.ToString
                    cbMaxCropSize.Checked = GetSetting("UseMaxCropSize", False)
                    sz = ParseSize(GetSetting("MaxCropSize", ""))
                    tbMaxCropWidth.Text = sz.Width.ToString
                    tbMaxCropHeight.Text = sz.Height.ToString
                    cbAspectRatio.Checked = GetSetting("UseAspectRatio", False)
                    sz = ParseSize(GetSetting("AspectRatio", ""))
                    tbRatioX.Text = sz.Width.ToString
                    tbRatioY.Text = sz.Height.ToString
                    cbRescale.Checked = GetSetting("Rescale", True)
                    cbAllowFileOpen.Checked = GetSetting("AllowFileOpen", True)
                    cbAllowFileUpload.Checked = GetSetting("AllowFileUpload", True)
                    cbAllowFileSave.Checked = GetSetting("AllowFileSave", True)
                    cbAllowFileSaveAs.Checked = GetSetting("AllowFileSaveAs", True)
                    cbShowFolders.Checked = GetSetting("ShowFolders", True)
                    cbShowSecure.Checked = GetSetting("ShowSecure", True)
                    cbShowDatabase.Checked = GetSetting("ShowDatabase", True)
                    cbShowFiles.Checked = GetSetting("ShowFiles", True)
                    tbQuality.Text = GetSetting("Quality", "80")
                    cbUseOctree.Checked = GetSetting("UseOctree", True)
                    cbAutoResize.Checked = GetSetting("AutoResize", True)
                    sz = ParseSize(GetSetting("MaxImageSize", "1024 x 768"))
                    tbMaxImageWidth.Text = sz.Width.ToString
                    tbMaxImageHeight.Text = sz.Height.ToString
                    cbAutoThumbnail.Checked = GetSetting("AutoThumbnail", True)
                    sz = ParseSize(GetSetting("MaxThumbSize", "200 x 200"))
                    tbMaxThumbWidth.Text = sz.Width.ToString
                    tbMaxThumbHeight.Text = sz.Height.ToString
                    tbThumbnailSuffix.Text = GetSetting("ThumbnailSuffix", "_th")
                    cbRememberLastFilepath.Checked = GetSetting("RememberLastFilepath", True)
                    tbFilepath.Text = GetSetting("Filepath", String.Empty)
                End If
            Catch exc As Exception           'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        Public Overrides Sub UpdateSettings()
            If Not Page.IsValid Then Exit Sub
            Try
                Dim objModules As New Entities.Modules.ModuleController
                Dim objPortalSecurity As New Security.PortalSecurity
                With objModules
                    .UpdateModuleSetting(ModuleId, "Caption", objPortalSecurity.InputFilter(tbCaption.Text, _
                                            PortalSecurity.FilterFlag.NoMarkup Or PortalSecurity.FilterFlag.NoAngleBrackets Or PortalSecurity.FilterFlag.NoSQL))
                    .UpdateModuleSetting(ModuleId, "AllowModeSwitch", cbAllowModeSwitch.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "InitialMode", rblInitialMode.SelectedValue)
                    .UpdateModuleSetting(ModuleId, "Orientation", rblOrientation.SelectedValue)
                    .UpdateModuleSetting(ModuleId, "ViewSize", rblViewSize.SelectedValue)
                    .UpdateModuleSetting(ModuleId, "PreviewSize", rblPreviewSize.SelectedValue)
                    .UpdateModuleSetting(ModuleId, "ShowCropperOnInit", cbShowCropperOnInit.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "CaptureKeys", cbCaptureKeys.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "UseMinCropSize", cbMinCropSize.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "MinCropSize", BuildSizeString(tbMinCropWidth, tbMinCropHeight))
                    .UpdateModuleSetting(ModuleId, "UseMaxCropSize", cbMaxCropSize.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "MaxCropSize", BuildSizeString(tbMaxCropWidth, tbMaxCropHeight))
                    .UpdateModuleSetting(ModuleId, "UseAspectRatio", cbAspectRatio.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "AspectRatio", BuildSizeString(tbRatioX, tbRatioY))
                    .UpdateModuleSetting(ModuleId, "Rescale", cbRescale.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "AllowFileOpen", cbAllowFileOpen.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "AllowFileUpload", cbAllowFileUpload.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "AllowFileSave", cbAllowFileSave.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "AllowFileSaveAs", cbAllowFileSaveAs.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "ShowFolders", cbShowFolders.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "ShowSecure", cbShowSecure.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "ShowDatabase", cbShowDatabase.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "ShowFiles", cbShowFiles.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "Quality", tbQuality.Text)
                    .UpdateModuleSetting(ModuleId, "UseOctree", cbUseOctree.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "AutoResize", cbAutoResize.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "MaxImageSize", BuildSizeString(tbMaxImageWidth, tbMaxImageHeight))
                    .UpdateModuleSetting(ModuleId, "AutoThumbnail", cbAutoThumbnail.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "MaxThumbSize", BuildSizeString(tbMaxThumbWidth, tbMaxThumbHeight))
                    .UpdateModuleSetting(ModuleId, "ThumbnailSuffix", objPortalSecurity.InputFilter(tbThumbnailSuffix.Text, PortalSecurity.FilterFlag.NoMarkup Or PortalSecurity.FilterFlag.NoSQL))
                    .UpdateModuleSetting(ModuleId, "RememberLastFilepath", cbRememberLastFilepath.Checked.ToString)
                    .UpdateModuleSetting(ModuleId, "Filepath", objPortalSecurity.InputFilter(tbFilepath.Text, _
                                                        PortalSecurity.FilterFlag.NoMarkup Or PortalSecurity.FilterFlag.NoSQL))
                End With
                ' refresh cache
                SynchronizeModule()
            Catch exc As Exception           'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

#End Region

#Region "Helper methods"

        Private Function GetSetting(Of T)(ByVal key As String, ByVal defaultVaue As T) As T
            Dim obj As Object = Settings(key)
            If obj Is Nothing OrElse CStr(key) = String.Empty Then
                Return defaultVaue
            Else
                If TypeOf defaultVaue Is System.Enum Then
                    Return CType([Enum].Parse(GetType(T), CStr(obj)), T)
                Else
                    Return CType(Settings(key), T)
                End If
            End If
        End Function

        Private Overloads Function ParseSize(ByVal xText As String, ByVal yText As String) As Size
            Dim X, Y As Integer
            If Not String.IsNullOrEmpty(xText.Trim()) Then
                X = Integer.Parse(xText.Trim())
            End If
            If Not String.IsNullOrEmpty(yText.Trim()) Then
                Y = Integer.Parse(yText.Trim())
            End If
            If (X = 0 And Y = 0) Then
                Return Size.Empty
            Else
                Return New Size(X, Y)
            End If
        End Function

        Private Overloads Function ParseSize(ByVal WbyH As String) As Size
            Dim value As String = WbyH.Trim()
            If Not String.IsNullOrEmpty(value) Then
                Dim m As RegularExpressions.Match = Regex.Match(value, "^(?<x>\d{1,4})\s*x\s*(?<y>\d{1,4})$")
                If m.Success Then
                    Return ParseSize(m.Groups(1).Value, m.Groups(2).Value)
                End If
            End If
            Return Size.Empty
        End Function

        Private Overloads Function BuildSizeString(ByVal wText As String, ByVal hText As String) As String
            Dim sz As Size = ParseSize(wText, hText)
            Return sz.Width.ToString & " x " & sz.Height.ToString
        End Function

        Private Overloads Function BuildSizeString(ByVal wTextbox As TextBox, ByVal hTextbox As TextBox) As String
            Return BuildSizeString(wTextbox.Text, hTextbox.Text)
        End Function


#End Region

    End Class

End Namespace

